import { JsonSchema } from '../types/types'

export const subscriptionSchema: JsonSchema = {
  $id: 'subscriptionSchema',
  type: 'object',
  properties: {
    id: { type: 'string' },
    object: { type: 'string' },
    cancel_at_period_end: { type: 'boolean' },
    current_period_end: { type: 'number' },
    current_period_start: { type: 'number' },
    default_payment_method: { type: 'string' },
    items: { type: 'object' },
    metadata: { type: 'object' },
    pending_setup_intent: { type: 'string' },
    pending_update: { type: 'object' },
    status: { type: 'string' },
    application_fee_percent: { type: 'number' },
    billing_cycle_anchor: { type: 'number' },
    billing_thresholds: { type: 'object' },
    cancel_at: { type: 'number' },
    canceled_at: { type: 'number' },
    collection_method: { type: 'string' },
    created: { type: 'number' },
    days_until_due: { type: 'number' },
    default_source: { type: 'string' },
    default_tax_rates: { type: 'object' },
    discount: { type: 'object' },
    ended_at: { type: 'number' },
    livemode: { type: 'boolean' },
    next_pending_invoice_item_invoice: { type: 'number' },
    pause_collection: { type: 'object' },
    pending_invoice_item_interval: { type: 'object' },
    start_date: { type: 'number' },
    transfer_data: { type: 'object' },
    trial_end: { type: 'object' },
    trial_start: { type: 'object' },
    schedule: { type: 'string' },
    customer: { type: 'string' },
    latest_invoice: { type: 'string' },
    plan: { type: 'string' },
  },
  required: ['id'],
} as const
