import Stripe from 'stripe'

const stripe = new Stripe(process.env.STRIPE_SECRET_KEY || '', {
  // https://github.com/stripe/stripe-node#configuration
  apiVersion: '2020-08-27',
  appInfo: {
    name: 'Stripe Postgres Sync',
  },
})

export default {
  webhooks: stripe.webhooks,
  invoices: {
    retrieve: jest.fn((id) =>
      Promise.resolve({
        id: id,
        object: 'invoice',
        account_country: 'SG',
        account_name: 'Supabase Pte Ltd',
        account_tax_ids: null,
        amount_due: 0,
        amount_paid: 0,
        amount_remaining: 0,
        application_fee_amount: null,
        attempt_count: 0,
        attempted: true,
        auto_advance: false,
        automatic_tax: {
          enabled: false,
          status: null,
        },
        billing_reason: 'subscription_cycle',
        charge: null,
        collection_method: 'charge_automatically',
        created: 1642595534,
        currency: 'usd',
        custom_fields: [
          {
            name: 'Project name',
            value: 'Test Project',
          },
        ],
        customer: 'cus_J7Mkgr8mvbl1eK',
        customer_address: null,
        customer_email: 'tesst@example.com',
        customer_name: null,
        customer_phone: null,
        customer_shipping: null,
        customer_tax_exempt: 'none',
        customer_tax_ids: [],
        default_payment_method: null,
        default_source: null,
        default_tax_rates: [],
        description: null,
        discount: null,
        discounts: [],
        due_date: null,
        ending_balance: 0,
        footer: null,
        hosted_invoice_url:
          'https://invoice.stripe.com/i/acct_1GThseJDPojXS6LN/test_YWNjdF8xR1Roc2VKRFBvalhTNkxOLF9LemNacGRVaG1iQ2NpV0RSTWxUU1lCZmtjcDVvb3pY01008P815B5b',
        invoice_pdf:
          'https://pay.stripe.com/invoice/acct_1GThseJDPojXS6LN/test_YWNjdF8xR1Roc2VKRFBvalhTNkxOLF9LemNacGRVaG1iQ2NpV0RSTWxUU1lCZmtjcDVvb3pY01008P815B5b/pdf',
        last_finalization_error: null,
        lines: {
          object: 'list',
          data: [
            {
              id: 'il_1KJdKkJDPojXS6LN2lyAeJz1',
              object: 'line_item',
              amount: 0,
              currency: 'usd',
              description: '1 × Free tier (at $0.00 / month)',
              discount_amounts: [],
              discountable: true,
              discounts: [],
              livemode: false,
              metadata: {
                project_id: '295',
                project_ref: 'zrsqozfrnjaqcdfbhvgq',
                project_name: 'bar',
                organization_id: '46',
                organization_slug: 'noisy-amethyst-guan',
              },
              period: {
                end: 1645273828,
                start: 1642595428,
              },
              plan: {
                id: 'price_1IDQm5JDPojXS6LNM31hxKzp',
                object: 'plan',
                active: false,
                aggregate_usage: null,
                amount: 0,
                amount_decimal: '0',
                billing_scheme: 'per_unit',
                created: 1611564617,
                currency: 'usd',
                interval: 'month',
                interval_count: 1,
                livemode: false,
                metadata: {},
                nickname: null,
                product: 'prod_Ip4vqwv3EJ7Mi0',
                tiers: null,
                tiers_mode: null,
                transform_usage: null,
                trial_period_days: null,
                usage_type: 'licensed',
              },
              price: {
                id: 'price_1IDQm5JDPojXS6LNM31hxKzp',
                object: 'price',
                active: false,
                billing_scheme: 'per_unit',
                created: 1611564617,
                currency: 'usd',
                livemode: false,
                lookup_key: null,
                metadata: {},
                nickname: null,
                product: 'prod_Ip4vqwv3EJ7Mi0',
                recurring: {
                  aggregate_usage: null,
                  interval: 'month',
                  interval_count: 1,
                  trial_period_days: null,
                  usage_type: 'licensed',
                },
                tax_behavior: 'unspecified',
                tiers_mode: null,
                transform_quantity: null,
                type: 'recurring',
                unit_amount: 0,
                unit_amount_decimal: '0',
              },
              proration: false,
              quantity: 1,
              subscription: 'sub_K4J0aB2bmSyb6b',
              subscription_item: 'si_K4J0IhgijHnskj',
              tax_amounts: [],
              tax_rates: [],
              type: 'subscription',
            },
          ],
          has_more: false,
          total_count: 1,
          url: '/v1/invoices/in_1KJdKkJDPojXS6LNSwSWkZSN/lines',
        },
        livemode: false,
        metadata: {},
        next_payment_attempt: null,
        number: 'B1AB464C-0181',
        on_behalf_of: null,
        paid: true,
        paid_out_of_band: false,
        payment_intent: null,
        payment_settings: {
          payment_method_options: null,
          payment_method_types: null,
        },
        period_end: 1642595428,
        period_start: 1639917028,
        post_payment_credit_notes_amount: 0,
        pre_payment_credit_notes_amount: 0,
        quote: null,
        receipt_number: null,
        starting_balance: 0,
        statement_descriptor: null,
        status: 'paid',
        status_transitions: {
          finalized_at: 1642599192,
          marked_uncollectible_at: null,
          paid_at: 1642599192,
          voided_at: null,
        },
        subscription: 'sub_K4J0aB2bmSyb6b',
        subtotal: 0,
        tax: null,
        tax_percent: null,
        total: 0,
        total_discount_amounts: [],
        total_tax_amounts: [],
        transfer_data: null,
        webhooks_delivered_at: 1642595537,
      })
    ),
  },
  subscriptions: {
    retrieve: jest.fn((id) =>
      Promise.resolve({
        id: id,
        object: 'subscription',
        application_fee_percent: null,
        billing_cycle_anchor: 1623148918,
        billing_thresholds: null,
        cancel_at: null,
        cancel_at_period_end: false,
        canceled_at: null,
        collection_method: 'charge_automatically',
        created: 1623148918,
        current_period_end: 1625740918,
        current_period_start: 1623148918,
        customer: 'cus_IhGfebO16cMIGN',
        days_until_due: null,
        default_payment_method: null,
        default_source: null,
        default_tax_rates: [],
        discount: null,
        ended_at: null,
        items: {
          object: 'list',
          data: [
            {
              id: 'si_JdIzi4Tn5jV9PD',
              object: 'subscription_item',
              billing_thresholds: null,
              created: 1623148918,
              metadata: {},
              plan: {
                id: 'price_1IDQm5JDPojXS6LNM31hxKzp',
                object: 'plan',
                active: true,
                aggregate_usage: null,
                amount: 0,
                amount_decimal: '0',
                billing_scheme: 'per_unit',
                created: 1611564617,
                currency: 'usd',
                interval: 'month',
                interval_count: 1,
                livemode: false,
                metadata: {},
                nickname: null,
                product: 'prod_Ip4vqwv3EJ7Mi0',
                tiers: null,
                tiers_mode: null,
                transform_usage: null,
                trial_period_days: null,
                usage_type: 'licensed',
              },
              price: {
                id: 'price_1IDQm5JDPojXS6LNM31hxKzp',
                object: 'price',
                active: true,
                billing_scheme: 'per_unit',
                created: 1611564617,
                currency: 'usd',
                livemode: false,
                lookup_key: null,
                metadata: {},
                nickname: null,
                product: 'prod_Ip4vqwv3EJ7Mi0',
                recurring: {
                  aggregate_usage: null,
                  interval: 'month',
                  interval_count: 1,
                  trial_period_days: null,
                  usage_type: 'licensed',
                },
                tiers_mode: null,
                transform_quantity: null,
                type: 'recurring',
                unit_amount: 0,
                unit_amount_decimal: '0',
              },
              quantity: 1,
              subscription: 'sub_JdIzvfy6o5GZRd',
              tax_rates: [],
            },
            {
              id: 'si_JdIzi4Tn5jVaaa',
              object: 'subscription_item',
              billing_thresholds: null,
              created: 1623148918,
              metadata: {},
              plan: {
                id: 'price_1IDQm5JDPojXS6LNM31hxKzp',
                object: 'plan',
                active: true,
                aggregate_usage: null,
                amount: 0,
                amount_decimal: '0',
                billing_scheme: 'per_unit',
                created: 1611564617,
                currency: 'usd',
                interval: 'month',
                interval_count: 1,
                livemode: false,
                metadata: {},
                nickname: null,
                product: 'prod_Ip4vqwv3EJ7Mi0',
                tiers: null,
                tiers_mode: null,
                transform_usage: null,
                trial_period_days: null,
                usage_type: 'licensed',
              },
              price: {
                id: 'price_1IDQm5JDPojXS6LNM31hxKzp',
                object: 'price',
                active: true,
                billing_scheme: 'per_unit',
                created: 1611564617,
                currency: 'usd',
                livemode: false,
                lookup_key: null,
                metadata: {},
                nickname: null,
                product: 'prod_Ip4vqwv3EJ7Mi0',
                recurring: {
                  aggregate_usage: null,
                  interval: 'month',
                  interval_count: 1,
                  trial_period_days: null,
                  usage_type: 'licensed',
                },
                tiers_mode: null,
                transform_quantity: null,
                type: 'recurring',
                unit_amount: 0,
                unit_amount_decimal: '0',
              },
              subscription: 'sub_JdIzvfy6o5GZRd',
              tax_rates: [],
            },
          ],
          has_more: false,
          total_count: 1,
          url: '/v1/subscription_items?subscription=sub_JdIzvfy6o5GZRd',
        },
        latest_invoice: 'in_1J02NeJDPojXS6LNaiyWfNwT',
        livemode: false,
        metadata: {
          project_id: '312',
          project_ref: 'tqevlzwwvzleheqncsph',
          project_name: 'temp webhooks',
          organization_id: '35',
          organization_slug: 'visible-emerald-fly',
        },
        next_pending_invoice_item_invoice: null,
        pause_collection: null,
        pending_invoice_item_interval: null,
        pending_setup_intent: null,
        pending_update: null,
        plan: {
          id: 'price_1IDQm5JDPojXS6LNM31hxKzp',
          object: 'plan',
          active: true,
          aggregate_usage: null,
          amount: 0,
          amount_decimal: '0',
          billing_scheme: 'per_unit',
          created: 1611564617,
          currency: 'usd',
          interval: 'month',
          interval_count: 1,
          livemode: false,
          metadata: {},
          nickname: null,
          product: 'prod_Ip4vqwv3EJ7Mi0',
          tiers: null,
          tiers_mode: null,
          transform_usage: null,
          trial_period_days: null,
          usage_type: 'licensed',
        },
        quantity: 1,
        schedule: null,
        start_date: 1623148918,
        status: 'active',
        tax_percent: null,
        transfer_data: null,
        trial_end: null,
        trial_start: null,
      })
    ),
  },
  customers: {
    retrieve: jest.fn((id) =>
      Promise.resolve({
        id: id,
        object: 'customer',
        address: null,
        balance: 0,
        created: 1609763141,
        currency: 'usd',
        default_source: null,
        delinquent: false,
        description: '[35 | visible-emerald-fly]: Copple Staging',
        discount: null,
        email: 'billz@supabase.io',
        invoice_prefix: 'D78833AC',
        invoice_settings: {
          custom_fields: null,
          default_payment_method: 'pm_1IfHHPJDPojXS6LNltyTwn3a',
          footer: null,
        },
        livemode: false,
        metadata: {
          supabase_org_id: '35',
        },
        name: 'Copple',
        next_invoice_sequence: 61,
        phone: '+6587498462',
        preferred_locales: [],
        shipping: {
          address: {
            city: '',
            country: '',
            line1: '',
            line2: '',
            postal_code: '',
            state: '',
          },
          name: 'Copple',
          phone: '+6587498462',
        },
        sources: {
          object: 'list',
          data: [],
          has_more: false,
          total_count: 0,
          url: '/v1/customers/cus_IhGfebO16cMIGN/sources',
        },
        subscriptions: {},
        tax_exempt: 'none',
        tax_ids: {
          object: 'list',
          data: [],
          has_more: false,
          total_count: 0,
          url: '/v1/customers/cus_IhGfebO16cMIGN/tax_ids',
        },
      })
    ),
  },
}
